<template lang="pug">
div
  .row.items-center.text-h5.q-mb-md User Whitelist:
    q-space
    q-btn(
      icon="add",
      dense,
      round,
      color="primary",
      @click="addingNewUser = true"
    )
  q-list(bordered, separator)
    q-item(v-if="addingNewUser")
      q-item-section.q-py-md
        q-form(@submit="addNewUser")
          q-input(dense, filled, label="Email", v-model="newUserEmail")
            template(v-slot:after)
              q-btn(label="Add", color="primary", @click="addNewUser")
    q-item(v-for="(email, key) in whitelist", :key="key")
      q-item-section.q-py-md {{ email }}
      q-item-section(avatar)
        q-btn(
          icon="delete",
          round,
          flat,
          dense,
          v-if="!requestingDelete[email]",
          @click="requestDelete(email)"
        )
        .row(v-else)
          q-btn(
            label="Cancel",
            flat,
            color="grey",
            @click="cancelRequestDelete(email)"
          )
          q-btn(
            label="Delete",
            flat,
            color="negative",
            @click="confirmDelete(email)"
          )
</template>
<script>
export default {
  props: {
    whitelist: { required: true },
    requestAddUserWithEmail: {
      required: true /* Callback of type: (email: string) => Promise<void> */,
    },
    requestDeleteUserWithEmail: {
      required: true /* Callback of type: (email: string) => Promise<void> */,
    },
  },
  data() {
    return {
      // Map of email to boolean
      // Each email that maps to true is currently being
      // requested to be deleted (so we render cancel and confirm buttons)
      requestingDelete: {},
      // Whether to render the new user form
      addingNewUser: false,
      // State for the new user's email
      newUserEmail: "",
    };
  },
  methods: {
    requestDelete(email) {
      this.requestingDelete = { ...this.requestingDelete, [email]: true };
    },
    cancelRequestDelete(email) {
      this.requestingDelete = { ...this.requestingDelete, [email]: false };
    },
    confirmDelete(email) {
      this.requestDeleteUserWithEmail(email).then(() =>
        this.$q.notify({
          type: "positive",
          message: `Deleted User ${email}`,
        }),
      );
    },
    addNewUser() {
      this.requestAddUserWithEmail(this.newUserEmail).then(() => {
        this.newUserEmail = "";
        this.addingNewUser = false;
        this.$q.notify({
          type: "positive",
          message: "New user added",
        });
      });
    },
  },
};
</script>
